/*  ư  ƥ   */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <sys/timeb.h>
#include <stdio.h>

#include "bitmap.h"   /*  ӥåȥޥåץǡɤ߹  */

#define UMAS 10       /*  फ  */

/*  ƥ饯ΥӥåȥޥåץǡؤΥݥ  */
static char *ishida_bits[UMAS] = {
  daiku_bits, man1_bits, man2_bits, narce_bits, osaru_bits, poli_bits,
  space_bits, uma_bits, ohneko_bits, kuronbo_bits
  };

/*  ƥ饯̾  */
static char *human_name[UMAS] = {
  "繩θ", "Ϻ", "", "İ屡ɽ",
  "󥭡", "ޤꤵ", "¥", "Ϥͩ",
  "ˤ", ""
  };

/*  ƽХߥʥ뤬䤷ǡΤ餬Ǥ(^^;) */
static char *speak[10] = {
  "", "ܤä", "ϥ(@@)", "ۥۥ", "ΤΤס",
  "ۤۡ", "ݤ", "褷Ƥ", "ؤ", "եե" 
  };

/*  ץ졼䡼λ  ߤΥȤǤ
    ۥ󥿡                            */
static unsigned long int osaifu = 10000, tousi = 0; 

/*  뤷ͤɽ졼ֹ  */
static int goal[4], race_number = 1; 

/*  ޤΣؤǻȤѿǤ  */
Display *keiba_display;
Window keiba_window;
GC keiba_gc;
XSetWindowAttributes keiba_att;
Font kanji, roman;
Pixmap black_coceci, pencil, pen_mask;

/*  ƥ饯¤  */
struct charactor {
  Pixmap pix;      /*  饯Υӥåȥޥåץǡ  */
  int x, y;        /*  饯ΰ  */
  int point;       /*  ɤդäƤ뤫ФƤѿ  */
} force[UMAS];

/*  ƥФ빽¤  */
struct cose_entry {
  struct charactor whoisthis;  /*  ΥͤΥ饯¤  */
  int human_type;              /*  ïΤФƤѿ  */
  int running_speed;           /*  ®  */
  int win_record;              /*  ԵϿ  */
  int ozz;                     /*  ʧᤷΨ  */
  int betting;                 /*  ߤƤ뤫ФƤѿ  */
} entry[4];

/*  ɥ򳫤Τμ³ؿ  */
init_screen()
{
  int i;
  XSizeHints keiba_xsh;

  keiba_display = XOpenDisplay( NULL );
  keiba_window = XCreateSimpleWindow( keiba_display,
				    RootWindow( keiba_display, 0),
				    0, 0, 600, 400, 2, 1, 0 );

  keiba_att.backing_store = Always;
  XChangeWindowAttributes( keiba_display, keiba_window,
			  CWBackingStore, &keiba_att );
  XMapWindow( keiba_display, keiba_window );
  keiba_gc = XCreateGC( keiba_display, keiba_window, 0, 0 );

  keiba_xsh.flags = PMinSize | PMaxSize;
  keiba_xsh.min_width = 600;
  keiba_xsh.max_width = 600;
  keiba_xsh.min_height = 400;
  keiba_xsh.max_height = 400;
  XSetNormalHints( keiba_display, keiba_window, &keiba_xsh );

  XStoreName( keiba_display, keiba_window, "undo-kai" );
  
  XSelectInput( keiba_display, keiba_window, ButtonPressMask );

  kanji = XLoadFont( keiba_display,
	    "-jis-fixed-medium-r-normal-*-16-100-*-*-*-*-jisx0208.1983-0" );
  roman = XLoadFont( keiba_display,
	    "-sony-fixed-medium-r-normal-*-16-100-*-*-*-*-iso8859-1" );
  XSetFont( keiba_display, keiba_gc, roman );

  XFlush( keiba_display );

  printf("\033[2H\033[2J\n\n");
  printf("[]--------------------------------------[]\n");
  printf(" | ư    ƥ |\n");
  printf(" |             ץǥ塼             |\n");
  printf(" | αƹ  ŻҾ󹩳ز |\n");
  printf(" |                ˧              |\n");
  printf(" |  e-mail : e924202@ed.kurume-it.ac.jp |\n");
  printf("[]--------------------------------------[]\n");
  printf("\n\n");

  sleep( 10 );
}

/*  饯¤ΤνǤ  */
init_char()
{
  int i;

  Colormap cm;
  XColor black, white, cc;
  Cursor cs;

  for ( i=0; i<UMAS; i++ ) {
    force[i].point = 0;
    force[i].x = 50; force[i].y = 50;
    force[i].pix = XCreateBitmapFromData( keiba_display, keiba_window,
					 ishida_bits[i], 40, 40 );
  }

  black_coceci = XCreateBitmapFromData( keiba_display, keiba_window,
				       black_bits, 40, 40 );

  cm = DefaultColormap( keiba_display, 0 );
  XAllocNamedColor( keiba_display, cm, "black", &black, &cc ); 
  XAllocNamedColor( keiba_display, cm, "white", &white, &cc ); 
  pencil = XCreateBitmapFromData( keiba_display, keiba_window,
				       pencil_bits, 16, 16 );
  pen_mask = XCreateBitmapFromData( keiba_display, keiba_window,
				       mask_bits, 16, 16 );
  cs = XCreatePixmapCursor( keiba_display, pencil, pen_mask,
			   &black, &white, 0, 15 );
  XDefineCursor( keiba_display, keiba_window, cs );

  XFlush( keiba_display );
}

/*  ͤ򥯥ꥢƥեɡХåɤο򥻥åȤޤ */
set_coceci( int f, int b )
{
  XSetForeground( keiba_display, keiba_gc, f );
  XSetBackground( keiba_display, keiba_gc, b );
  XSetFillStyle( keiba_display, keiba_gc, FillOpaqueStippled );
  XSetStipple( keiba_display, keiba_gc, black_coceci );
}

/*  ꤵ줿֤ʸ񤭤ޤ  */
print_text( int x, int y, char s[] )
{
  int i, k;
  char string[2];

  set_coceci( 1, 0 ); 

  i = 0; k = 0;
  while ( s[i]!=0 ) {
    if ( (s[i] & 0x80)!=0 && k==0 ) {
      k = 1;
      XSetFont( keiba_display, keiba_gc, kanji );
    }
    if ( (s[i] & 0x80)==0 && k==1 ) {
      k = 0;
      XSetFont( keiba_display, keiba_gc, roman );
    }

    if ( k==0 ) {
      XDrawString( keiba_display, keiba_window, keiba_gc,
		  x+i*8, y+20, &s[i], 1 );
      i++;
    }
    if ( k==1 ) {
      string[0] = s[i]   & 0x7f;
      string[1] = s[i+1] & 0x7f;
      XDrawString16( keiba_display, keiba_window, keiba_gc,
		    x+i*8, y+20, (XChar2b *)string, 1 );
      i+=2;
    }
  }
  XFlush( keiba_display );
}

/*  ꥸʥ륦ɥ褹ؿ  */
ishida_window( int x, int y, int w, int h )
{
  set_coceci( 1, 0 );
  XFillRectangle( keiba_display, keiba_window, keiba_gc,
		 x+5, y+5, w, h );
  XFillRectangle( keiba_display, keiba_window, keiba_gc,
		 x, y, w, h );

  set_coceci( 0, 1 );
  XFillRectangle( keiba_display, keiba_window, keiba_gc,
		 x+1, y+1, w-2, h-2 );
  XFlush( keiba_display );
}  

/*  ɥ  */
win1()
{
  char num[4][7] = { "ڣ", "2", "3", "4" };
  int i;

  ishida_window(  10,  10, 250, 360 );
  set_coceci( 1, 0 );
  XDrawRectangle( keiba_display, keiba_window, keiba_gc, 40,  90, 202, 2 );
  XDrawRectangle( keiba_display, keiba_window, keiba_gc, 40, 340, 202, 2 );
  for ( i=0; i<5; i++ ) {
    XDrawRectangle( keiba_display, keiba_window, keiba_gc,
		   i*50+40, 90, 2, 250 );
  }
  for ( i=0; i<4; i++ )
    print_text( i*50+45, 15, num[i] );
  XFlush( keiba_display );
}  

/*  ɥ  */
win2()
{
  int i; 
  char tc[] = " Ծ ";

  ishida_window( 280,  10, 300, 220 );
  print_text( 300,  10, tc );
  for ( i=0; i<5; i++ )
    XDrawRectangle( keiba_display, keiba_window, keiba_gc,
		   290, i*45+40, 280, 2 );
  XDrawRectangle( keiba_display, keiba_window, keiba_gc,
		 290, 40, 2, 180 );
  XDrawRectangle( keiba_display, keiba_window, keiba_gc,
		 568, 40, 2, 180 );
  XFlush( keiba_display );
}

/*  ɥ  */
win3()
{
  char tc[] = " ⥢ʥ ";

  ishida_window( 280, 250, 300, 120 );
  print_text( 300, 250, tc );
  XFlush( keiba_display );
}

/*  ̺  */
draw_lines()
{
  win1();
  win2();
  win3();
} 

/*  饯ɽؿ  */
put_char( struct charactor ishida ) 
{
  XSetForeground( keiba_display, keiba_gc, 1 );
  XSetBackground( keiba_display, keiba_gc, 0 );
  XSetFillStyle( keiba_display, keiba_gc, FillOpaqueStippled );
  XSetStipple( keiba_display, keiba_gc, ishida.pix );
  XSetTSOrigin( keiba_display, keiba_gc, ishida.x, ishida.y );
  XFillRectangle( keiba_display, keiba_window, keiba_gc,
		 ishida.x, ishida.y, 40, 40 );
  XFlush( keiba_display );
}

/*  饯õؿ  */
black( int x, int y )
{
  set_coceci( 0, 1 );
  XSetTSOrigin( keiba_display, keiba_gc, x, y );
  XFillRectangle( keiba_display, keiba_window, keiba_gc,
		 x, y, 40, 40 );
  XFlush( keiba_display );
}  

/*  ꤬äƤ꤫ɸ׻ɽ  */
human( struct charactor *ishida, int cose )
{
  int x, y;

  x = ishida->x; y = ishida->y;
  ishida->x  = ishida->point % 3 + cose*50-4;
  ishida->y  = ishida->point  / 10 + 40;
  if ( y!=ishida->y ) {
    black( x, y );
    put_char( *ishida );
  }
  if ( x==ishida->x ) return;
  else {
    set_coceci( 0, 1 );
    XFillRectangle( keiba_display, keiba_window, keiba_gc,
		      x, y, 2, 40 );
    XFillRectangle( keiba_display, keiba_window, keiba_gc,
		      x+38, y, 2, 40 );
    put_char( *ishida );
  }
}

/*  ꤬Ȥƥ뤹ޤ餻³ؿ  */
running()
{
  int i, j, k, r, f, g;
  struct timeb now;

  ftime( &now );
  for ( i=0; i<now.millitm; i++ ) rand();

  win3();
  print_text( 300, 270, "ǤϡȤޤ");
  sleep(1);

  for ( i=0; i<100; i++ ) {
    for ( j=0; j<4; j++ ) {
      entry[j].whoisthis.point ++;
      human( &(entry[j].whoisthis), j+1 );
    }
  }

  sleep(1);
  print_text( 300, 290, "ꥹȥ饤դޤ" );
  sleep(3);
  print_text( 300, 310, "" );
  sleep(1);
  print_text( 300, 330, "ɤ" );

  j = 0; g = 0;
  do {
    r = ( rand()/1001 ) % 4; 
    if ( entry[r].whoisthis.y<250 ) {
      entry[r].whoisthis.point ++;
      human( &(entry[r].whoisthis), r+1 );
    }
    if ( entry[r].whoisthis.y>=250 && entry[r].whoisthis.y<310) {
      if ( (rand()/1000)%2==0 ) {
	for ( k=0; k<((entry[r].running_speed)/2+1); k++ ) {
	  entry[r].whoisthis.point ++;
	  human( &(entry[r].whoisthis), r+1 );
	  if ( entry[r].whoisthis.point==2600 ) {
	    goal[g++]=r;
	  }
	}
      }
      entry[r].whoisthis.point ++;
      human( &(entry[r].whoisthis), r+1 );
      if ( entry[r].whoisthis.point==2600 ) {
	goal[g++]=r;
      }
    }
    
    if ( j==600 ) win3(); 

    f = 0;
    for ( i=0; i<4; i++ )
      if ( entry[i].whoisthis.y <310 ) f = 1;
    j ++;

  } while ( f );

  sleep(5);
}

/*  ĤΥ룴ȴ entry ¤ΤΥСͤ */
force_select()
{
  int i, r, j, z, e[4];
  struct timeb now;

  win1();

  ftime( &now );
  for ( i=0; i<now.millitm; i++ ) rand();
 
  for ( i=0; i<4; i++ ) {
    do {
      r = rand()%UMAS;
      e[i] = r;
      j = 0;
      while ( e[j]!=r ) j++;
    } while ( j!=i );
    entry[i].whoisthis = force[r];
    entry[i].whoisthis.x = (i+1)*50-4;
    entry[i].whoisthis.y = 40;
    entry[i].human_type = r;
    entry[i].betting = 0; 
    entry[i].running_speed = (rand()/1000)%9+1;
    entry[i].win_record = (((rand()/1000)%10)*entry[i].running_speed)%6;
    for ( j=0; j<z; j++ ) rand();
    if ( entry[i].win_record >= 3 && ((rand()/1000)%10)==0 )
      entry[i].ozz = ((rand()/1000)%100+1)*(11-entry[i].running_speed)%89+10;
    else 
      entry[i].ozz = ((rand()/1000)%100+1)*(11-entry[i].running_speed)%30+10;
    put_char( entry[i].whoisthis );
  }
  sleep(1);
}

/*  Ϳ줿ͥǡʸɽؿ  */
number( int mx, int my, unsigned long int num, int c )
{
  unsigned long int i, x, y; 
  char buffer[25];

  if ( c>8 ) c = 8;
  for ( i=0; i<10; i++ )
    buffer[i*2] = 0xa3;
  x = 1;
  for ( i=0; i<c; i++ ) 
    x = x * 10;
  y = num % x; i = 1; x /= 10; 
  while ( x>0 ) {
    buffer[i] = y / x + 0xb0;
    y = y % x; x /= 10; i += 2;
  }
  buffer[i-1] = 0;
  print_text( mx, my, buffer );
}

/*  ƥνԤξɽ  */
show_entry()
{
  char *cose_number[4] = { "", "", "", "" };
  char *maru_sankaku[6] = { "", "", "", "", "", "" };
  char message[10];
  int i, j, y;

  printf("\033[A%s        \n", speak[rand()%10] ); 

  sleep(3);
  win3();
  print_text( 350, 300, "");
  number( 366, 300, race_number++, 5 );
  print_text( 446, 300, "졼" );
  sleep(1);

  win2();
  for ( i=0; i<4; i++ ) {
    y = 40+i*45;
    print_text( 300, y, cose_number[i] );
    print_text( 320, y, human_name[ entry[i].human_type ] );

    print_text( 430, y, "ݶ  " );

    print_text( 320, y+20, "Ψ" );
    print_text( 360, y+20, maru_sankaku[ entry[i].win_record ] );

    print_text( 430, y+20, "졼" );
    message[0] = message[4] = 0xa3;
    message[2] = 0xa1;
    message[1] = entry[i].ozz/10 + 0xb0 ;
    message[5] = entry[i].ozz%10 + 0xb0 ;
    message[3] = 0xa5;
    message[6] = 0;
    print_text( 490, y+20, message );
    sleep(1);
  }
  sleep(1);
}    

/*  ݤؿ  */
int sankaku( int x, int y )
{
  int i, f;
  
  f = 1;
  for ( i=0; i<4; i++ ) {
    if ( (i*45+46)<y && y<(i*45+62) ) {
      if ( 478<x && x<494 ) {
	if ( entry[i].betting < 999 && osaifu >= 100 ) {
	  print_text( 478, y*45+40, "" );
	  entry[i].betting ++;
	  osaifu -= 100;
	  XFlush( keiba_display );
	}
      }
      if ( 542<x && x<558 ) {
	if ( entry[i].betting > 0 ) {
	  print_text( 542, y*45+40, "" );
	  entry[i].betting --;
	  osaifu += 100;
	  XFlush( keiba_display );
	}
      }
    }
  }
  if ( 460<x && x<540 && 334<y && y<350 ) f=0;
  if ( 300<x && x<412 && 334<y && y<350 ) f=2;

  return f;
}

/*  ݤؿ  */
sub_betting()
{
  int i, flag, t;
  XEvent ev;

  t = osaifu; 
  do {
    XNextEvent( keiba_display, &ev );
    flag = sankaku( ev.xbutton.x, ev.xbutton.y );
  
    for ( i=0; i<4; i++ ) {
      set_coceci( 0, 1 );
      XFillRectangle( keiba_display, keiba_window, keiba_gc,
		     478, i*45+44, 80, 20 );

      print_text( 478, i*45+40, "" );
      print_text( 542, i*45+40, "" );
      number( 494, i*45+40, entry[i].betting, 3 ); 
    }
    set_coceci( 0, 1 );
    XFillRectangle( keiba_display, keiba_window, keiba_gc,
		   380, 314, 128, 20 );
    number( 380, 310, osaifu, 8 );
    XFlush( keiba_display );
  } while ( flag==1 );
  tousi += t - osaifu;

  if ( flag==2 ) {
    XCloseDisplay( keiba_display );
    printf("\033[2J\033[2H\n");
    printf("    \n\n");
    printf("ȶ  \\%8d.\n", 10000 );
    printf("ǽ    \\%8d.\n", osaifu );
    printf("      \\%8d.\n", tousi );
    if ( osaifu>=10000 ) 
      printf("ʧᤷ  \\%8d.\n", osaifu-10000 ); 
    printf("\n");
 
    printf("٤ΰ˸ĺޤͭ񤦸¤ޤ\n");
    printf("ޤθ졢餪ԤƤޤ\n\n");
    exit( 0 );
  }
}

/*  ݤؿ  */
betting()
{
  int status;

  win3();
  print_text( 300, 270, "򤫤Ƥ");
  sleep(1);
  print_text( 300, 290, "ʤν" );
  sleep(1);
  number( 380, 310, osaifu, 8 );
  print_text( 510, 310, "ߤǤ" );
  sleep(1);
  print_text( 300, 330, "Υཪλ    ɼλ" );
  sleep(1);

  sub_betting();
}

/*  ɽؿ  */
goal_money()
{
  int i, okane;
  char *chaku[4] = { "", "", "", "" };  
  char *run_cose[4] = { "", "", "", "" };

  okane = entry[ goal[0] ].ozz * entry[ goal[0] ].betting * 10;

  win3();
  print_text( 300, 270, "졼η̤Τ餻ޤ");
  sleep(3);
  win3();
  for ( i=0; i<4; i++ ) {
    print_text( 300, 270+i*20, chaku[i] );
    print_text( 350, 270+i*20, human_name[ entry[ goal[i] ].human_type ] ); 
    print_text( 460, 270+i*20, run_cose[ goal[i] ] );
    sleep(1);
  }
  sleep(5);
  win3();
  print_text( 300, 290, "" );
  sleep(1);
  number( 400, 310, okane, 6 );
  print_text( 496, 310, "ߤǤ" );
  sleep(1);
  if ( okane > 0 )
    print_text( 300, 330, "ǤȤޤ" );
  else 
    print_text( 300, 330, "ǰǤ" );
  sleep(3);

  osaifu += okane;
}

/*  ᥤ롼  */
main()
{
  init_screen();
  init_char();
  draw_lines();

  while ( 1 ) {
    force_select();
    show_entry();
    betting();
    running();
    goal_money();
  }
}
